# LevyArea.jl
*Iterated Stochastic Integrals in Julia*

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://stochastics-uni-luebeck.github.io/LevyArea.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://stochastics-uni-luebeck.github.io/LevyArea.jl/dev)
[![Build Status](https://github.com/stochastics-uni-luebeck/LevyArea.jl/workflows/CI/badge.svg)](https://github.com/stochastics-uni-luebeck/LevyArea.jl/actions)

This package implements state-of-the-art methods for the simulation of iterated stochastic integrals.
These appear e.g. in higher order algorithms for the solution of stochastic (partial) differential equations.

## Installation

This package can be installed from the Julia package manager (type <kbd>]</kbd>)
```julia
pkg> add LevyArea
```

## Usage Example

Load the package and generate a Wiener increment:
```julia-repl
julia> using LevyArea
julia> m = 5; # dimension of Wiener process
julia> h = 0.01; # step size or length of time interval
julia> err = 0.05; # error bound
julia> W = sqrt(h) * randn(m); # increment of Wiener process
```
Here, $W$ is the $m$-dimensional vector of increments of the driving
Wiener process on some time interval of length $h$.

The default call uses h^(3/2) as the precision and chooses the best algorithm automatically:
```julia-repl
julia> II = iterated_integrals(W,h)
```
If not stated otherwise, the default error criterion is the $\max,L^2$-error
and the function returns the $m \times m$ matrix `II` containing a realisation
of the approximate iterated stochastic integrals that correspond
to the given increment $W$.

The desired precision can be optionally provided
using a third positional argument:
```julia-repl
julia> II = iterated_integrals(W,h,err)
```
Again, the software package automatically chooses the optimal
algorithm.

To determine which algorithm is chosen by the package without simulating any iterated
stochastic integrals yet, the function `optimal_algorithm` can
be used. The arguments to this function are the dimension of the Wiener
process, the step size and the desired precision:
```julia-repl
julia> alg = optimal_algorithm(m,h,err); # output: Fourier()
```

It is also possible to choose the algorithm directly using the
keyword argument `alg`. The value can be one of
`Fourier()`, `Milstein()`, `Wiktorsson()` and `MronRoe()`:
```julia-repl
julia> II = iterated_integrals(W,h; alg=Milstein())
```

As the norm for the considered error, e.g., the $\max,L^2$- and $\mathrm{F},L^2$-norm
can be selected using a keyword argument. The corresponding
values are `MaxL2()` and `FrobeniusL2()`:
```julia-repl
julia> II = iterated_integrals(W,h,err; error_norm=FrobeniusL2())
```

If iterated stochastic integrals for some $Q$-Wiener process need to
be simulated, like for the numerical simulation of solutions to SPDEs,
then the increment of the $Q$-Wiener process together with the
square roots of the eigenvalues of the associated covariance
operator have to be provided:
```julia-repl
julia> q = [1/k^2 for k=1:m]; # eigenvalues of cov. operator
julia> QW = sqrt(h) * sqrt.(q) .* randn(m); # Q-Wiener increment
julia> IIQ = iterated_integrals(QW,sqrt.(q),h,err)
```
In this case, the function `iterated_integrals` utilizes a
scaling of the iterated stochastic integrals and also adjusts the error
estimates appropriately such that the error bound holds w.r.t.\ the
iterated stochastic integrals $\mathcal{I}^{Q}(h)$ based on the
$Q$-Wiener process. Here the error norm defaults to the $\mathrm{F},L^2$-error.

Note that all discussed keyword arguments are optional and can be
combined as needed. 

Additional information can be found, e.g., using the Julia help mode:
```julia-repl
julia> ?iterated_integrals
julia> ?optimal_algorithm
```
or by reading the [documentation](https://stochastics-uni-luebeck.github.io/LevyArea.jl/stable/).

## Related Packages

A Matlab version of this package is also available under [LevyArea.m](https://github.com/stochastics-uni-luebeck/LevyArea.m).

using Documenter, LevyArea

# Make sure that doctests in docstrings have the package available
DocMeta.setdocmeta!(LevyArea, :DocTestSetup, :(using LevyArea); recursive=true)

makedocs(
    sitename = "LevyArea.jl",
    modules = [LevyArea],
    authors = "Felix Kastner <kastner.felix@gmail.com>",
    repo = "https://github.com/stochastics-uni-luebeck/LevyArea.jl/blob/{commit}{path}#L{line}",
    pages = [
        "Home" => "index.md",
        "Index" => "functions.md",
        "References" => "references.md"
    ],
    format = Documenter.HTML(;
        prettyurls = get(ENV, "CI", "false") == "true",
        canonical = "https://stochastics-uni-luebeck.github.io/LevyArea.jl",
        assets = String[],
    ),
    strict = true
)

deploydocs(;
    repo = "github.com/stochastics-uni-luebeck/LevyArea.jl",
    devbranch = "main",
    push_preview = true
)

# Wiktorsson method
# First published by Wiktorsson, 2001

struct Wiktorsson <: AbstractIteratedIntegralAlgorithm end

convorder(::Wiktorsson) = 1//1
errcoeff(m, h, ::Wiktorsson, ::MaxL2) = √(5*m)*h/(√12*π)
norv(m, n, ::Wiktorsson) = 2*m*n+(m^2-m)÷2


"""
    levyarea(W, n, alg::Wiktorsson)

Simulates an approximation of the iterated Itô-integrals ``\\int_0^1W_s\\otimes dW_s``
of the given ``m``-dimensional increment of a Wiener process with step size 1.
The parameter ``n`` specifies the number of terms in the approximation and thus determines the accuracy.
This is an efficient implementation of the algorithm proposed in [Wiktorsson, 2001](@ref wiktorsson2001).
It is based on the Fourier method from Milstein but incorporates an additional tail sum approximation.
The algorithm needs approximately ``2\\cdot m^2+2\\cdot m\\cdot n+m`` Float's.
The time complexity is ``\\mathcal{O}(m^2\\cdot n)``.
"""
function levyarea(W::AbstractVector{T}, n::Integer, alg::Wiktorsson) where {T<:AbstractFloat}
    rng = default_rng()
    m = length(W)
    # Preallocate
    A = similar(W,m,m) # allocates m*m Floats
    G = similar(W,m,m) # allocates m*m Floats
    # 1. Simulate Xₖ and Yₖ and approximate stochastic area integral
    X = randn(rng, T, n, m) # allocates m*n Floats
    Y = randn(rng, T, m, n) # allocates m*n Floats
    Y .= (Y .- √(T(2)).*W) ./ (1:n)'
    mul!(A,Y,X)
    # 2.a Simulate Gₙ
    a = T(√(2*trigamma(n+1)))
    for j=1:m
        @inbounds G[j,j] = zero(T)
        for i=j+1:m
            g = a * randn(rng, T)
            @inbounds G[i,j] = g
            @inbounds G[j,i] = -g
            @inbounds A[i,j] += g
        end
    end
    # 2.b and add the tail-sum approximation
    A .+= inv(1+√(1+W'*W)) .* (G*W) .* W' # allocates m Floats
    # 3. Calculate the iterated integrals
    G .= inv(2*T(π)).*(A .- A') # reuse G to save allocations
    return G
end

# Fourier method
# First published by Milstein, 1994

struct Milstein <: AbstractIteratedIntegralAlgorithm end

convorder(::Milstein) = 1//2
errcoeff(m, h, ::Milstein, ::MaxL2) = h/(√2*π)
norv(m, n, ::Milstein) = 2*m*n+m


"""
    levyarea(W, n, alg::Milstein)

Simulates an approximation of the iterated Itô-integrals ``\\int_0^1W_s\\otimes dW_s``
of the given ``m``-dimensional increment of a Wiener process with step size 1.
The parameter ``n`` specifies the number of terms in the approximation and thus determines the accuracy.
This is an efficient implementation of the algorithm proposed in [Milstein, 1994](@ref milstein1994).
It is based on a Fourier expansion of the Wiener process.
The algorithm needs approximately ``m^2+2\\cdot m\\cdot n`` Float's.
The time complexity is ``\\mathcal{O}(m^2\\cdot n)``.
"""
function levyarea(W::AbstractVector{T}, n::Integer, alg::Milstein) where {T<:AbstractFloat}
    rng = default_rng()
    m = length(W)
    X = randn(rng, T, n, m) # allocates m*n Floats
    Y = randn(rng, T, m, n) # allocates m*n Floats
    Y .= (Y .- √(T(2)).*W) ./ (1:n)'
    A = Y * X # allocates m*m Floats
    # Add simple rest approximation (a₀)
    # M = randn(rng, T, m) # allocates m Floats
    M = randn!(rng, view(Y, :, 1))
    a = T(√(2*trigamma(n+1)))
    A .+= a .* W .* M'
    # Antisymmetrize
    # G = inv(2*T(π)).*(A .- A') # allocates m*m Floats
    for i = 1:m
        @inbounds A[i,i] = zero(T)
        for j = (i+1):m
            @inbounds A[i,j] = (A[i,j] - A[j,i])/(2*T(π))
            @inbounds A[j,i] = -A[i,j]
        end
    end
    return A
end

module LevyArea

# Imports
import LinearAlgebra: mul!
import Random: randn!, default_rng
import SpecialFunctions: trigamma


"""
    abstract type AbstractIteratedIntegralAlgorithm end

Abstract type for algorithms for the simulation of iterated integrals.

```jldoctest; setup=:(using InteractiveUtils; using LevyArea)
julia> subtypes(AbstractIteratedIntegralAlgorithm)
4-element Vector{Any}:
 Fourier
 Milstein
 MronRoe
 Wiktorsson
```
"""
abstract type AbstractIteratedIntegralAlgorithm end


# Define error criteria
include("error_norms.jl")
export MaxL2
export FrobeniusL2

# Simulate in terms of Levy Area
include("iterated_integrals.jl")
export iterated_integrals

# Properties of Levy Area algorithms
include("alg_utils.jl")
export terms_needed
export optimal_algorithm

# Levy Area algorithms
include("fourier.jl")
include("milstein.jl")
include("wiktorsson.jl")
include("mronroe.jl")
export AbstractIteratedIntegralAlgorithm
export Fourier
export Milstein
export Wiktorsson
export MronRoe

const ITER_INT_ALGS = [Fourier(),Milstein(),Wiktorsson(),MronRoe()]


end # module

"""
    ito_correction!(I, h=1)

Applies the Itô-correction for iterated integrals to `I`.
This amounts to subtracting ``\\frac{1}{2}h`` from every element on the diagonal.

# Example
```jldoctest; setup=:(using LevyArea)
julia> M = ones(5,5);

julia> LevyArea.ito_correction!(M, 0.5)


julia> M
5×5 Matrix{Float64}:
 0.75  1.0   1.0   1.0   1.0
 1.0   0.75  1.0   1.0   1.0
 1.0   1.0   0.75  1.0   1.0
 1.0   1.0   1.0   0.75  1.0
 1.0   1.0   1.0   1.0   0.75
```

"""
function ito_correction!(I, h=1)
    m,n = size(I)
    m == n || throw(DimensionMismatch("Matrix is not square: dimensions are $(size(I))"))
    @inbounds for i=1:m
        I[i,i] -= h/2
    end
end

"""
    iterated_integrals(W::AbstractVector, h, eps=h^(3/2);
        ito_correction=true,
        error_norm=MaxL2(),
        alg=optimal_algorithm(length(W),h,eps,error_norm)
    )

Simulates an approximation of the iterated stochastic integrals
``\\int_0^h\\int_0^sdW_i(t)dW_j(s)`` for all pairs ``1\\le i, j \\le m``
of the given ``m``-dimensional Brownian motion with step size h.

# Examples
```jldoctest; setup=:(using LinearAlgebra; using LevyArea)
julia> h = 1/2;

julia> W = [1.0, 0.5]
2-element Vector{Float64}:
 1.0
 0.5

julia> diag(iterated_integrals(W, h, h^(3/2))) ≈ 0.5*W.^2 .- 0.5h
true
```
"""
function iterated_integrals(W::AbstractVector{T}, h::Real, eps::Real=h^(3/2);
    ito_correction=true,
    error_norm::AbstractErrorNorm=MaxL2(),
    alg::AbstractIteratedIntegralAlgorithm=optimal_algorithm(length(W),h,eps,error_norm)
) where {T<:AbstractFloat}
    m = length(W)
    n = terms_needed(m, h, eps, alg, error_norm)
    I = levyarea(W/√h, n, alg)
    if ito_correction
        ito_correction!(I)
    end
    I .= 0.5.*W.*W' .+ h.*I
    return I
end

"""
    iterated_integrals(W::AbstractVector, q_12::AbstractVector, h, eps; 
        ito_correction=true,
        error_norm=FrobeniusL2(),
        alg=optimal_algorithm(length(W),q_12,h,eps,error_norm)
    )

Simulates an approximation of the iterated stochastic integrals for finite-dimensional approximations of
a Q-Wiener process with covariance matrix ``Q = Q^\\frac{1}{2}*Q^\\frac{1}{2}``.
Here `q_12` is a vector of the eigenvalues of ``Q^\\frac{1}{2}``; the square root of the covariance matrix.
Equivalently these are the square roots of the eigenvalues of ``Q``.

# Examples
```jldoctest; setup=:(using LinearAlgebra; using LevyArea)
julia> h = 0.01; dim=10; q = [1/k^2 for k=1:dim];

julia> W = √h * sqrt.(q) .* randn(dim);

julia> diag(iterated_integrals(W,sqrt.(q),h,h^(3/2))) ≈ 0.5*W.^2 .- 0.5*h*q
true
```
"""
function iterated_integrals(W::AbstractVector{T}, q_12::AbstractVector, h::Real, eps::Real;
    ito_correction=true,
    error_norm::AbstractErrorNorm=FrobeniusL2(),
    alg::AbstractIteratedIntegralAlgorithm=optimal_algorithm(length(W),q_12,h,eps,error_norm)
) where {T<:AbstractFloat}
    m = length(W)
    n = terms_needed(m, q_12, h, eps, alg, error_norm)
    I = levyarea(W./q_12./√h, n, alg)
    if ito_correction
        ito_correction!(I)
    end
    I .= 0.5.*W.*W' .+ h.*q_12'.*I.*q_12 # scale correctly
    return I
end

"""
    iterated_integrals(W::Real, h::Real, eps::Real=0.0; ito_correction=true, kwargs...)

In the case of a scalar Brownian motion the integral can be explicitly
calculated as ``\\int_0^h\\int_0^sdW(t)dW(s) = \\frac{1}{2}W(h)^2 - \\frac{1}{2}h``.

The parameter `eps` (as well as all additional keyword arguments) has no effect but is available 
to provide the same interface as the multidimensional version.
"""
iterated_integrals(W::Real, h::Real, eps::Real=0.0; ito_correction=true, kwargs...) = ito_correction ? 0.5W^2 - 0.5h : 0.5W^2

"""
    iterated_integrals(W::Real, q_12::Real, h::Real, eps::Real; ito_correction=true, kwargs...)

In the case of a scalar Q-Wiener process with (scalar) covariance Q the integral can be explicitly
calculated as ``\\int_0^h\\int_0^sdW(t)dW(s) = \\frac{1}{2}W(h)^2 - \\frac{1}{2}hQ``.

Note that, as in the multidimensional case, the parameter `q_12` denotes the square root of the covariance.

The parameter `eps` (as well as all additional keyword arguments) has no effect but is available 
to provide the same interface as the multidimensional version.
"""
iterated_integrals(W::Real, q_12::Real, h::Real, eps::Real; ito_correction=true, kwargs...) = ito_correction ? 0.5W^2 - 0.5*h*q_12^2 : 0.5W^2

using LevyArea
using Test, BenchmarkTools
import Random
import LinearAlgebra: diag

BenchmarkTools.DEFAULT_PARAMETERS.seconds = 1
Random.seed!(638278)

@testset "Iterated Integrals" begin
    @testset "m=1, h=$h" for h in rand(5)
        W = √h * randn()
        Ints = iterated_integrals(W, h, h^(3/2))
        @test Ints == 0.5W^2 - 0.5h
    end

    #trigger compilation
    for alg ∈ LevyArea.ITER_INT_ALGS
        iterated_integrals(randn(2),0.1,0.1, alg=alg)
    end
    
    h = 0.0001
    ϵ = h^(3/2)
    println("h = $h, ϵ = $ϵ")
    @testset "Alg $alg: m=$m" for alg ∈ LevyArea.ITER_INT_ALGS, m in [2;10;50;100;500]
        W = √h * randn(m)
        print("Alg $alg: m=$m n=$(terms_needed(m,h,ϵ,alg,MaxL2())) cost=$(LevyArea.effective_cost(m,h,ϵ,alg,MaxL2()))")
        @btime iterated_integrals($W, $h, $ϵ, alg=$alg) # stepsize h
        Ints = iterated_integrals(W, h, ϵ, alg=alg) # stepsize h
        @test diag(Ints) ≈ 0.5*W.^2 .- 0.5h
    end
end

# Note: All the estimates and inequalities below only apply
# for our iterated integrals because the Levy area and the 
# corresponding error terms are skew-symmetric!

"""
    abstract type AbstractErrorNorm end

Abstract type for different kind of errors one might consider.
The most important are `MaxL2` and `FrobeniusL2`. These are actually
special cases of the `MaxLp{p}` and `SchattenqLp{p,q}` norms:
```julia
const MaxL2 = MaxLp{2}
const FrobeniusL2 = SchattenqLp{2,2}
```

All currently defined norms:
```jldoctest; setup=:(using InteractiveUtils; using LevyArea)
julia> subtypes(LevyArea.AbstractErrorNorm)
3-element Vector{Any}:
 LevyArea.LpMax
 LevyArea.MaxLp
 LevyArea.SchattenqLp
```
"""
abstract type AbstractErrorNorm end


# maximum of entry-wise Lp norms
# this requires new Lp convergence proofs
# and should be defined for each new algorithm
struct MaxLp{p} <: AbstractErrorNorm end

function errcoeff(m, q_12, stepsize, alg::AbstractIteratedIntegralAlgorithm, ::MaxLp{p}) where {p}
    maxqq = maximum(q_12[i]*q_12[j] for i=1:m for j=1:i-1)
    return maxqq * errcoeff(m, stepsize, alg, MaxLp{p}())
end

# lq norm of eigenvalues of matrix of entry-wise Lp norms
# (= Schatten-q norm of matrix of entry-wise Lp norms)
# we can get this from the MaxLp norms
# p=q=2 is the FrobeniusL2 norm
struct SchattenqLp{p,q} <: AbstractErrorNorm end

function errcoeff(m, stepsize, alg::AbstractIteratedIntegralAlgorithm, ::SchattenqLp{p,q}) where {p,q}
    return (m^2-m)^(1/q) * errcoeff(m, stepsize, alg, MaxLp{p}())
end
function errcoeff(m, q_12, stepsize, alg::AbstractIteratedIntegralAlgorithm, ::SchattenqLp{p,q}) where {p,q}
    trQq_sq = abs2(sum(x->x^q, q_12))
    tr_Qqsq = sum(x->x^2q, q_12)
    return (trQq_sq-tr_Qqsq)^(1/q) * errcoeff(m, stepsize, alg, MaxLp{p}())
end

# Lp norm of maximum of matrix
# can be bounded by the SchattenqLp norm with q=p
# (this relies on the fact that Schatten-p-Lp == Lp-Schatten-p)
# the factor 1/2^1/p comes from the antisymmetry
struct LpMax{p} <: AbstractErrorNorm end

function errcoeff(m, stepsize, alg::AbstractIteratedIntegralAlgorithm, ::LpMax{p}) where {p}
    return 1/(2^(1/p)) * errcoeff(m, stepsize, alg, SchattenqLp{p,p}())
end
function errcoeff(m, q_12, stepsize, alg::AbstractIteratedIntegralAlgorithm, ::LpMax{p}) where {p}
    return 1/(2^(1/p)) * errcoeff(m, q_12, stepsize, alg, SchattenqLp{p,p}())
end


# most important/common norms
const MaxL2 = MaxLp{2}
const FrobeniusL2 = SchattenqLp{2,2}

# Mrongowius-Rößler method
# First published by Mrongowius & Rößler, 2021

struct MronRoe <: AbstractIteratedIntegralAlgorithm end

convorder(::MronRoe) = 1//1
errcoeff(m, h, ::MronRoe, ::MaxL2) = √m*h/(√12*π)
norv(m, n, ::MronRoe) = 2*m*n+(m^2+m)÷2


"""
    levyarea(W, n, alg::MronRoe)

Simulates an approximation of the iterated Itô-integrals ``\\int_0^1W_s\\otimes dW_s``
of the given ``m``-dimensional increment of a Wiener process with step size 1.
The parameter ``n`` specifies the number of terms in the approximation and thus determines the accuracy.
This is an efficient implementation of the algorithm proposed in [Mrongowius & Rößler, 2021](@ref mr2021).
It is based on the Fourier method from Milstein but incorporates an improved tail sum approximation.
The algorithm needs approximately ``m^2+2\\cdot m\\cdot n`` Float's 
and ``1/2m^2+2\\cdot m\\cdot n + 1/2m`` random numbers.
The time complexity is ``\\mathcal{O}(m^2\\cdot n)``.
"""
function levyarea(W::AbstractVector{T}, n::Integer, alg::MronRoe) where {T<:AbstractFloat}
    rng = default_rng()
    m = length(W)
    # 1. Simulate Xₖ and Yₖ and approximate stochastic area integral
    X = randn(rng, T, m, n) # allocates m*n Floats
    Y = randn(rng, T, n, m) # allocates m*n Floats
    Y .= (Y .- √(T(2)).*W') ./ (1:n)
    A = X * Y # allocates m*m Floats
    
    # 2. Add first, simple rest approximation (a₀)
    Ψ = randn!(rng, view(X, :, 1))
    a = T(sqrt(2*trigamma(n+1)))
    A .+= a .* W .* Ψ'

    # 3. Add improved tail-sum approximation and antisymmetrize (A.-=A')
    for i = 1:m
        @inbounds A[i,i] = zero(T)
        for j = (i+1):m
            @inbounds A[i,j] = (A[i,j] + a*randn(rng, T) - A[j,i])/(2*T(π))
            @inbounds A[j,i] = -A[i,j]
        end
    end

    return A
end

"""
    convorder(alg::AbstractIteratedIntegralAlgorithm)

Returns the convergence order of the algorithm w.r.t. the truncation parameter.

See also: [`errcoeff`](@ref)
"""
function convorder end

"""
    errcoeff(dim, stepsize, alg, norm)
    errcoeff(dim, q_12, stepsize, alg, norm)

Returns the coefficient of the truncation parameter in the error estimate.
I.e. the error estimate is of the form

```math
\\lVert I(h)-\\tilde{I}^{(p)}(h) \\rVert_* ≤ \\mathrm{errcoeff}(m,h) \\cdot p^{-γ}
```

where the norm is given by `norm`, the approximation ``\\tilde{I}^{(p)}`` is 
calculated using `alg` and ``γ`` is the order of convergence given by [`convorder(alg)`](@ref).
"""
function errcoeff end

"""
    terms_needed(dim, stepsize, eps, alg, norm)
    
Returns the number of terms in the approximating sum that is needed to ensure an error
in the given norm of at most `eps`.
This depends on the dimension of the Wiener process `dim`, the current stepsize and the chosen algorithm.
    
See also: [`AbstractIteratedIntegralAlgorithm`](@ref), [`AbstractErrorNorm`](@ref)

# Examples
```jldoctest; setup=:(using LevyArea)
julia> h = 1/128;

julia> terms_needed(10, h, h^(3/2), Milstein(), MaxL2())
7
```

# Implementation
New algorithms should only have to implement [`errcoeff`](@ref) and [`convorder`](@ref).
"""
function terms_needed(dim, stepsize, eps, alg::AbstractIteratedIntegralAlgorithm, norm::AbstractErrorNorm)
    ceil(Int64, (errcoeff(dim, stepsize, alg, norm)/eps)^(1//convorder(alg)) )
end

"""
    terms_needed(dim, q_12, stepsize, eps, alg, norm)
    
Used for finite-dimensional approximations of a Q-Wiener process with covariance matrix
``Q = Q^\\frac{1}{2}*Q^\\frac{1}{2}``. Here `q_12` is a vector of the eigenvalues of ``Q^\\frac{1}{2}``;
the square root of the covariance matrix. Equivalently these are the square roots of the eigenvalues of ``Q``.

# Examples
```jldoctest; setup=:(using LevyArea)
julia> h = 1/128;

julia> dim = 10;

julia> q = [1/k^2 for k=1:dim];

julia> terms_needed(dim, sqrt.(q), h, h^(3/2), Milstein(), FrobeniusL2())
9
```
"""
function terms_needed(dim, q_12, stepsize, eps, alg::AbstractIteratedIntegralAlgorithm, norm::AbstractErrorNorm)
    length(q_12) == dim || throw(ArgumentError("Length of q_12 must be equal to the dimension."))
    ceil(Int64, (errcoeff(dim, q_12, stepsize, alg, norm)/eps)^(1//convorder(alg)) )
end

"""
    norv(dim, n, alg::AbstractIteratedIntegralAlgorithm)

Returns the number of random numbers needed to simulate the iterated integrals
for a Wiener process of dimension `dim` and with truncation parameter `n`.
"""
norv(dim, n, alg::AbstractIteratedIntegralAlgorithm)

"""
    effective_cost(dim, stepsize, eps, alg, norm)
    effective_cost(dim, q_12, stepsize, eps, alg, norm)

Returns the number of random numbers needed to simulate the iterated integrals
with the given parameters.
"""
function effective_cost(dim, stepsize, eps, alg, norm)
    norv(dim, terms_needed(dim, stepsize, eps, alg, norm), alg)
end
function effective_cost(dim, q_12, stepsize, eps, alg, norm)
    norv(dim, terms_needed(dim, q_12, stepsize, eps, alg, norm), alg)
end


"""
    optimal_algorithm(dim, stepsize, eps=stepsize^(3/2), norm=MaxL2())
    optimal_algorithm(dim, q_12, stepsize, eps, norm=FrobeniusL2())

Returns the optimal algorithm for the given parameters,
i.e. the algorithm that needs to simulate the fewest random numbers
to achieve the desired precision `eps`.

# Examples
```jldoctest; setup=:(using LevyArea)
julia> h = 1/128;

julia> optimal_algorithm(10, h, h^(3/2), MaxL2())
MronRoe()

julia> optimal_algorithm(10, 1.0./(1:10).^2, h, h^(3/2), FrobeniusL2())
Milstein()
```
"""
function optimal_algorithm(dim, stepsize, eps=stepsize^(3/2), norm::AbstractErrorNorm=MaxL2())
    ind = argmin([effective_cost(dim, stepsize, eps, alg, norm) for alg ∈ ITER_INT_ALGS])
    return ITER_INT_ALGS[ind]
end
function optimal_algorithm(dim, q_12, stepsize, eps, norm::AbstractErrorNorm=FrobeniusL2())
    ind = argmin([effective_cost(dim, q_12, stepsize, eps, alg, norm) for alg ∈ ITER_INT_ALGS])
    return ITER_INT_ALGS[ind]
end

# Function reference

```@meta
DocTestSetup = :(using LinearAlgebra; using LevyArea)
```

## Main Functions

```@docs
iterated_integrals
LevyArea.levyarea
LevyArea.AbstractIteratedIntegralAlgorithm
LevyArea.AbstractErrorNorm
optimal_algorithm
```

## Algorithmic properties

```@docs
terms_needed
LevyArea.convorder
LevyArea.errcoeff
LevyArea.norv
LevyArea.effective_cost
```

## Helper functions

```@docs
LevyArea.ito_correction!
```

## Index

```@index
```

# References

###### [Milstein, 1994](@id milstein1994)
> Milstein, G. N.,
> *"Numerical integration of stochastic differential equations."*
>
> Vol. 313. Springer Science & Business Media, 1995. DOI: [10.1007/978-94-015-8455-5](https://doi.org/10.1007/978-94-015-8455-5).

###### [Mrongowius & Rößler, 2021](@id mr2021)
> Mrongowius, J. and Rößler, A.,
> *"On the Approximation and Simulation of Iterated Stochastic Integrals and the Corresponding Lévy Areas in Terms of a Multidimensional Brownian Motion."*
>
> Stochastic Analysis and Applications (2021), pp. 1–29. arXiv: [2101.09542](https://arxiv.org/abs/2101.09542). DOI: [10.1080/07362994.2021.1922291](https://doi.org/10.1080/07362994.2021.1922291).

###### [Wiktorsson, 2001](@id wiktorsson2001)
> Wiktorsson, M.,
> *"Joint Characteristic Function and Simultaneous Simulation of Iterated Itô Integrals for Multiple Independent Brownian Motions."*
>
> The Annals of Applied Probability 11.2 (2001), pp. 470-487. DOI: [10.1214/aoap/1015345301](https://doi.org/10.1214/aoap/1015345301).
